// Bibliotheken zum Einbinden (Zufallszahlen, Ein-Ausgabe,Mathematik)
#include <cstdlib>
#include <stdio.h>
#include <math.h>
#include "hilf.h"
#include "vector2.h"
#include <iostream>
#include "graphik.h"
using namespace std;

void zufall(int n,float *x) 
 // n zufallszahlen auf (0,1)
// Parameter seed.. Zeit in sec seit 1.1.1970 (im 1. Schritt)
//     fuer zufaellige Initialisierung der Zufallszahlen    
//     Typ ist static int, d.h. bei erneutem Aufruf 
//     wird diese Variable auf den alten Wert gesetzt.
{
  unsigned long int m,z1,z,k;
  static long int seed=time(0);
  static long int z0=1;
  z1=seed;
  m=2*(32768*32768-1)+1;
  for (k=1;k<n+1;k++)
    {
      z=(1999*z1+4444*z0)%m; // Generation gemaess Vorlesung
      z0=z1;
      z1=z;  
      x[k-1]=float(z)/float(m); // Transformation auf [0,1)
    }
   seed=z1;
}



void Monopoly_Zufall(int *n1,int *n2, int *n3)
// zieht 3 Zufallszahlen
// n1,n2 Zahlen fuer den Wuerfel 1..6 gleichverteilt
// n3 Karte fuer Ereignis/Gemeinsschaftsfeld, 
// d.h. 1..16 gleichverteilt
{
  const int N=3;
  float x[N];  
  zufall(3,x); // Ziehen von 3 Zufallszahlen
  *n1=1+int(floor(6)*x[0]);
  *n2=1+int(floor(6)*x[1]);
  *n3=1+int(floor(16)*x[2]);
}

void monopoly(long int *x,int m)
// x.. Zufallsgroesse der felder
// m anzahl ziehungen
// k.. aktuelles feld im Spielplan 0..39 (Los-Schlossallee)
// r .. Parameter fuer Pasch
{ int l,n1,n2,n3;
  int r,k;
  k=0;
  r=0;
  l=0;
  while (l<m)
    { 
      // Wuerfeln und evtl. Karte ziehen
      Monopoly_Zufall(&n1,&n2,&n3);
      l=l+1;
      if (n1==n2) 
        {
         r=r+1;
        }
      else
        {
	  r=0;
        }
      // 3 mal Pasch-> Gefaengnis
      if (r==3) 
        {
        k=10;
        }
      else
        {  
	  k=(k+n1+n2)%40;
        }
      // Ereignisfeld
      if ((k==7)||(k==22)||(k==36))
           { 
	     if (n3==1) k=0;  // auf Los
             if (n3==2) k=1;  // auf Badstrasse
             if (n3==3) k=11;  // Seestrasse
             if (n3==4) k=24;  // Opernplatz
             if (n3==5) k=39;  // Schlossallee
             if (n3==6) k=10;  // Gefaengnis
             if (n3==7) k=k-3;  // 3 Schritte zurueck
             if (n3==8) k=5; //Suedbahnhof
             if (n3==9) k=(k+9-((k+4)%10))%40; // na. Bhf.
           }
	 //Gemeinschaftskarte 
      if ((k==2)||(k==18)||(k==33))
           {
             if (n3==1) k=10; // Gefaengnis
             if (n3==2) k=0;  // Start
           }
         // Gefaengnis
         if (k==30) k=10; 
         x[k]=x[k]+1;
         if (k==10) r=0; 
    }
 }


int main()
{ const int N=40;
  long int x[N];
  long int c[N];
  int k,m;
  double y[N];
  cout<< "m  ?";
  cin >> m;
  for (k=0;k<40;k++)
    {
      x[k]=0;
    }
  monopoly(x,m);
  Farben(c);
  PlotBalken(x,40,c);
  for (k=0;k<40;k++)
    {
      y[k]=double(x[k])/double(m);
    }
  ausgabe(y,40);
  return 0;
}
